
Global Sound1, Font1, Event, OldPosition, Loop, Loop2, Page, Sound2                    
Global mx,my,x0,y0,x1,y1  
Global Space, Space2, Panel, PieceClicked, Position, Piece
Dim x(10)                             ; start locations of 6 columns
Dim y(10)                             ; start locations of 3 rows
Dim Pce( 10,5 )                       ; 9 pieces, 4 numbers each
Dim PieceLocation( 10 )               ; location = 1 to 18
Dim Square(20)                        ; 18 squares contains pieces #1 to #9 or 0
Dim Pcx(10)                           ; start locations of 9 pieces
Dim Pcy(10)                           ; start locations of 9 pieces

Loop = 1                           
Page = 1                       
Loop2 = 1
Event = 1
Function Start()
 ; *************
End Function

Graphics 1000,700,16,2
SetBuffer BackBuffer()

ClsColor 180,200,255
Cls
SetData()
SuffleData()

Setup1()
Setup2()
  
  
 
  MakePanel()
  ; Main loop

 While Loop2 = 1
  Delay 50
  Cls
  value=GetKey()
  If value = 32 Then    Loop2=0                 ; break out of loop
  If value = 49 Then    Page = 1
  If value = 50 Then    Page = 2
  MouseCheck()
      Delay 50                 
      MakePanel()
      If Page = 1 Then Instructions()
      If Page = 2 Then DisplayText()
        Logic2()

  VWait
  Flip
 Wend
End

Function MouseCheck()

  Local a,b,c,ax,ay,cnt 

  mx = MouseX()
  my = MouseY()
  cnt = 1
  ay = x(1)
  If MouseDown(1) Then            ; Get Position clicked  1-18

     For a = 1 To 3
          ay = y(a)
        For b = 1 To 3
           ax = x(b)
           If mx > ax And mx < ax + 120 And my > ay And my < ay + 120 Then 
              Position = cnt : x0 = ax : y0 = ay
           End If  
        cnt = cnt + 1  
        Next
     Next 

     For a = 1 To 3
          ay = y(a)
        For b = 4 To 6
           ax = x(b)
          If mx > ax And mx < ax + 120 And my > ay And my < ay + 120 Then 
             Position = cnt : x0 = ax : y0 = ay
          End If 
        cnt = cnt + 1  
        Next
     Next

     Logic1()
 

  End If 


End Function

Function Logic1()

        If Position > 0  And Event = 1 And Square(Position) > 0 Then  
           PieceClicked = Square(Position)
           PieceLocation( PieceClicked ) = Position
           Event = 2
           OldPosition = Position
           PlaySound Sound1
        End If
        Delay 50
        If Position > 0 And Event = 2 And Square(Position) = 0 Then
           Square(Position) = PieceClicked
           Pcx( PieceClicked ) = x0
           Pcy( PieceClicked ) = y0
           PlaySound Sound2
           Square(OldPosition) = 0
           Event = 1 
        End If 
End Function 

Function Logic2()

        If Position > 0  And Event = 2 And Square(Position) > 0 Then
               VWait
               Flip
               DrawImage Space2,x0,y0
               Delay 1
 
        End If 


End Function

Function MakePanel()
  
  Local a 
  DrawImage Panel,50,195
  DrawImage Panel,550,195
       
 
  DrawImage Space,60,205
  DrawImage Space,60,335
  DrawImage Space,190,205
  DrawImage Space,190,335
  DrawImage Space,320,205
  DrawImage Space,320,335
  DrawImage Space,60,465
  DrawImage Space,190,465
  DrawImage Space,320,465

  DrawImage Space,560,205
  DrawImage Space,560,335
  DrawImage Space,690,205
  DrawImage Space,690,335
  DrawImage Space,820,205
  DrawImage Space,820,335
  DrawImage Space,560,465
  DrawImage Space,690,465
  DrawImage Space,820,465
  For a = 1 To 9
     DrawImage Piece,Pcx(a),Pcy(a),a

  Next



End Function
  
Function DisplayText()

  Local a
 
  Text 300, 100, Str PieceClicked
  Text 300, 130, Str Square(Position)
  Text 300, 160, Str Position
  Text 300, 70, Str PieceLocation( PieceClicked )
  Text 300, 40, Str Event
  Text 10,10, Str x0
  Text 100,10, Str y0


  Text 10, 100, "PieceClicked"
  Text 10, 130, "Square(Position)"
  Text 10, 160, "Position"
  Text 10, 70,  "PieceLocation"
  Text 10, 40,  "Event"

  ;Text 10, 215, " "
  ;Text 10, 230, " "
  Color 40,40,40
  ;Text 20, 600, Str mx
  ;Text 20, 630, Str my
 
End Function

Function Instructions()

  Local a
  
   Color 40,40,40
  Text 10,10, "           HOW TO PLAY "
  Text 10,40, "  Click on a square in the right side panel to select it."
  Text 10,70, "  Click on an empty space in the left panel to place it."
  Text 10,100, "  The puzzle is solved when all the numbers match " 
  Text 10,130, "  near-by numbers. "
   
  Text 8,620, "      http://rb23.yolasite.com "
 
 
End Function




Function Setup1()

   Local a
   
 
   rightarrow = LoadImage ( "Data\rightarrow.bmp")
   leftarrow = LoadImage ( "Data\leftarrow.bmp")
  
   Space = CreateImage (120,120)
   Space2 = CreateImage (120,120)

   Panel = CreateImage (400,400)
   Piece = CreateImage (120,120,10)

    Font1 = LoadFont("Arial",32,1,0,0)
    SetFont Font1

    Sound1 = LoadSound("Data\boink4.wav")
    Sound2 = LoadSound("Data\boink2.wav")

 
   x(1)=60 : x(2) = 190 : x(3) = 320 : x(4) = 560 : x(5) = 690 : x(6) = 820 
   y(1) = 205 : y(2) = 335 : y(3) = 465

  
   Square(10) = 1 : Square(11) = 2 : Square(12) = 3 : Square(13) = 4 : Square(14) = 5 : Square(15) = 6  
   Square(16) = 7 : Square(17) = 8 : Square(18) = 9
 
   Pcx(1) = 560 : Pcx(2) = 690 : Pcx(3) = 820 : Pcx(4) = 560 : Pcx(5) = 690 : Pcx(6) = 820 : Pcx(7) = 560 : Pcx(8) = 690 : Pcx(9) = 820 
   Pcy(1) = 205 : Pcy(2) = 205 : Pcy(3) = 205 : Pcy(4) = 335 : Pcy(5) = 335 : Pcy(6) = 335 : Pcy(7) = 465 : Pcy(8) = 465 : Pcy(9) = 465




End Function 

Function Setup2()

   Local a
  

   Color 200,200,255
   SetBuffer ImageBuffer(Space)
   Rect 0,0,120,120,2

   Color 250,150,200
   SetBuffer ImageBuffer(Space2)
   Rect 0,0,120,120,2



    Color 255,255,255

    SetBuffer ImageBuffer(Panel)
    Rect 0,0,400,400,2


   Color 0,0,10
   Line  0,0,400,0 :Line  0,1,400,1 :Line  0,2,400,2 :Line  0,3,400,3  
   Line  0,399,400,399 :Line  0,398,400,398 :Line  0,397,400,397 :  Line  0,396,400,396  
   Line  0,0,0,400 : Line  1,0,1,400 : Line  2,0,2,400 : Line  3,0,3,400 
   Line  400,0,400,400 : Line  399,0,399,400 : Line  398,0,398,400 : Line  397,0,397,400 : Line  396,0,396,400 

  Color 55,55,55
  For a = 1 To 9 
   SetBuffer ImageBuffer(Piece,a)
   Rect 0,0,120,120,2
  Next

  Color 200,180,255
  For a = 1 To 9 
   SetBuffer ImageBuffer(Piece,a)
   Rect 4,4,112,112,2
 
  Next
 
  Color 55,55,55
  For a = 1 To 9 
   SetBuffer ImageBuffer(Piece,a)
      Line 0,0,120,120
      Line 0,120,120,0
      Text 52,10, Str Pce(a,1)
      Text 90,45, Str Pce(a,2)
      Text 52,75, Str Pce(a,3)
      Text 20,45, Str Pce(a,4)

  Next

   SetBuffer BackBuffer()
 
End Function

Function SetData()
 ;Pce(10,5)
Local a,b,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16,d17,d18,d19,d20
 
SeedRnd MilliSecs() 
d1 = Rand( 1,9) : d5 = Rand( 1,9) : d9 = Rand( 1,9) : d13 = Rand( 1,9) : d17 = Rand( 1,9) 
d2 = Rand( 1,9) : d6 = Rand( 1,9) : d10 = Rand( 1,9) : d14 = Rand( 1,9) : d18 = Rand( 1,9)  
d3 = Rand( 1,9) : d7 = Rand( 1,9) : d11 = Rand( 1,9) : d15 = Rand( 1,9) : d19 = Rand( 1,9)  
d4 = Rand( 1,9) : d8 = Rand( 1,9) : d12 = Rand( 1,9) : d16 = Rand( 1,9) : d20 = Rand( 1,9)  
    Pce(1,1)=d20 : Pce(1,2)=d14 : Pce(1,3)=d13 : Pce(1,4)=d15 
    Pce(2,1)=d19 : Pce(2,2)=d12 : Pce(2,3)=d1  : Pce(2,4)=d14
    Pce(3,1)=d18 : Pce(3,2)=d11 : Pce(3,3)=d10 : Pce(3,4)=d12
    Pce(4,1)=d13 : Pce(4,2)=d4  : Pce(4,3)=d9  : Pce(4,4)=d17
    Pce(5,1)=d1  : Pce(5,2)=d2  : Pce(5,3)=d3  : Pce(5,4)=d4
    Pce(6,1)=d10 : Pce(6,2)=d16 : Pce(6,3)=d8  : Pce(6,4)=d2
    Pce(7,1)=d9  : Pce(7,2)=d7  : Pce(7,3)=d5  : Pce(7,4)=d4
    Pce(8,1)=d3  : Pce(8,2)=d6  : Pce(8,3)=d5  : Pce(8,4)=d7
    Pce(9,1)=d8  : Pce(9,2)=d2  : Pce(9,3)=d3  : Pce(9,4)=d6
 

End Function

Function SuffleData()
     
Local a,b,c,d

  d = Rand( 3,8 )
  For c = 1 To d  
    For a = 1 To 4 
       b = Pce(1,a) : Pce(1,a) = Pce(2,a) :  Pce(2,a) = Pce(3,a) :  Pce(3,a) = b
    Next 

    For a = 1 To 4 
       b = Pce(7,a) : Pce(7,a) = Pce(8,a) :  Pce(8,a) = Pce(9,a) :  Pce(9,a) = b
    Next

    For a = 1 To 4 
       b = Pce(1,a) : Pce(1,a) = Pce(4,a) :  Pce(4,a) = Pce(7,a) :  Pce(7,a) = b
    Next 
 
    For a = 1 To 4 
       b = Pce(3,a) : Pce(3,a) = Pce(6,a) :  Pce(6,a) = Pce(9,a) :  Pce(9,a) = b
    Next
    For a = 1 To 4 
       b = Pce(4,a) : Pce(4,a) = Pce(5,a) :  Pce(5,a) = Pce(6,a) :  Pce(6,a) = b
    Next
    For a = 1 To 4 
       b = Pce(2,a) : Pce(2,a) = Pce(5,a) :  Pce(5,a) = Pce(8,a) :  Pce(8,a) = b
    Next
   Next


End Function 